# coding: utf-8

"""
    PortainerCE API

    Portainer API is an HTTP API served by Portainer. It is used by the Portainer UI and everything you can do with the UI can be done using the HTTP API. Examples are available at https://documentation.portainer.io/api/api-examples/ You can find out more about Portainer at [http://portainer.io](http://portainer.io) and get some support on [Slack](http://portainer.io/slack/).  # Authentication  Most of the API endpoints require to be authenticated as well as some level of authorization to be used. Portainer API uses JSON Web Token to manage authentication and thus requires you to provide a token in the **Authorization** header of each request with the **Bearer** authentication mechanism.  Example:  ``` Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpZCI6MSwidXNlcm5hbWUiOiJhZG1pbiIsInJvbGUiOjEsImV4cCI6MTQ5OTM3NjE1NH0.NJ6vE8FY1WG6jsRQzfMqeatJ4vh2TWAeeYfDhP71YEE ```  # Security  Each API endpoint has an associated access policy, it is documented in the description of each endpoint.  Different access policies are available:  - Public access - Authenticated access - Restricted access - Administrator access  ### Public access  No authentication is required to access the endpoints with this access policy.  ### Authenticated access  Authentication is required to access the endpoints with this access policy.  ### Restricted access  Authentication is required to access the endpoints with this access policy. Extra-checks might be added to ensure access to the resource is granted. Returned data might also be filtered.  ### Administrator access  Authentication as well as an administrator role are required to access the endpoints with this access policy.  # Execute Docker requests  Portainer **DOES NOT** expose specific endpoints to manage your Docker resources (create a container, remove a volume, etc...).  Instead, it acts as a reverse-proxy to the Docker HTTP API. This means that you can execute Docker requests **via** the Portainer HTTP API.  To do so, you can use the `/endpoints/{id}/docker` Portainer API endpoint (which is not documented below due to Swagger limitations). This endpoint has a restricted access policy so you still need to be authenticated to be able to query this endpoint. Any query on this endpoint will be proxied to the Docker API of the associated endpoint (requests and responses objects are the same as documented in the Docker API).  **NOTE**: You can find more information on how to query the Docker API in the [Docker official documentation](https://docs.docker.com/engine/api/v1.30/) as well as in [this Portainer example](https://documentation.portainer.io/api/api-examples/).   # noqa: E501

    OpenAPI spec version: 2.6.0
    Contact: info@portainer.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from portainer_ce_api.configuration import Configuration


class PortainerSettings(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'allow_bind_mounts_for_regular_users': 'bool',
        'allow_container_capabilities_for_regular_users': 'bool',
        'allow_device_mapping_for_regular_users': 'bool',
        'allow_host_namespace_for_regular_users': 'bool',
        'allow_privileged_mode_for_regular_users': 'bool',
        'allow_stack_management_for_regular_users': 'bool',
        'allow_volume_browser_for_regular_users': 'bool',
        'authentication_method': 'int',
        'black_listed_labels': 'list[PortainerPair]',
        'edge_agent_checkin_interval': 'int',
        'enable_edge_compute_features': 'bool',
        'enable_host_management_features': 'bool',
        'enable_telemetry': 'bool',
        'ldap_settings': 'PortainerLDAPSettings',
        'logo_url': 'str',
        'o_auth_settings': 'PortainerOAuthSettings',
        'snapshot_interval': 'str',
        'templates_url': 'str',
        'user_session_timeout': 'str',
        'display_donation_header': 'bool',
        'display_external_contributors': 'bool'
    }

    attribute_map = {
        'allow_bind_mounts_for_regular_users': 'AllowBindMountsForRegularUsers',
        'allow_container_capabilities_for_regular_users': 'AllowContainerCapabilitiesForRegularUsers',
        'allow_device_mapping_for_regular_users': 'AllowDeviceMappingForRegularUsers',
        'allow_host_namespace_for_regular_users': 'AllowHostNamespaceForRegularUsers',
        'allow_privileged_mode_for_regular_users': 'AllowPrivilegedModeForRegularUsers',
        'allow_stack_management_for_regular_users': 'AllowStackManagementForRegularUsers',
        'allow_volume_browser_for_regular_users': 'AllowVolumeBrowserForRegularUsers',
        'authentication_method': 'AuthenticationMethod',
        'black_listed_labels': 'BlackListedLabels',
        'edge_agent_checkin_interval': 'EdgeAgentCheckinInterval',
        'enable_edge_compute_features': 'EnableEdgeComputeFeatures',
        'enable_host_management_features': 'EnableHostManagementFeatures',
        'enable_telemetry': 'EnableTelemetry',
        'ldap_settings': 'LDAPSettings',
        'logo_url': 'LogoURL',
        'o_auth_settings': 'OAuthSettings',
        'snapshot_interval': 'SnapshotInterval',
        'templates_url': 'TemplatesURL',
        'user_session_timeout': 'UserSessionTimeout',
        'display_donation_header': 'displayDonationHeader',
        'display_external_contributors': 'displayExternalContributors'
    }

    def __init__(self, allow_bind_mounts_for_regular_users=None, allow_container_capabilities_for_regular_users=None, allow_device_mapping_for_regular_users=None, allow_host_namespace_for_regular_users=None, allow_privileged_mode_for_regular_users=None, allow_stack_management_for_regular_users=None, allow_volume_browser_for_regular_users=None, authentication_method=None, black_listed_labels=None, edge_agent_checkin_interval=None, enable_edge_compute_features=None, enable_host_management_features=None, enable_telemetry=None, ldap_settings=None, logo_url=None, o_auth_settings=None, snapshot_interval=None, templates_url=None, user_session_timeout=None, display_donation_header=None, display_external_contributors=None, _configuration=None):  # noqa: E501
        """PortainerSettings - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._allow_bind_mounts_for_regular_users = None
        self._allow_container_capabilities_for_regular_users = None
        self._allow_device_mapping_for_regular_users = None
        self._allow_host_namespace_for_regular_users = None
        self._allow_privileged_mode_for_regular_users = None
        self._allow_stack_management_for_regular_users = None
        self._allow_volume_browser_for_regular_users = None
        self._authentication_method = None
        self._black_listed_labels = None
        self._edge_agent_checkin_interval = None
        self._enable_edge_compute_features = None
        self._enable_host_management_features = None
        self._enable_telemetry = None
        self._ldap_settings = None
        self._logo_url = None
        self._o_auth_settings = None
        self._snapshot_interval = None
        self._templates_url = None
        self._user_session_timeout = None
        self._display_donation_header = None
        self._display_external_contributors = None
        self.discriminator = None

        if allow_bind_mounts_for_regular_users is not None:
            self.allow_bind_mounts_for_regular_users = allow_bind_mounts_for_regular_users
        if allow_container_capabilities_for_regular_users is not None:
            self.allow_container_capabilities_for_regular_users = allow_container_capabilities_for_regular_users
        if allow_device_mapping_for_regular_users is not None:
            self.allow_device_mapping_for_regular_users = allow_device_mapping_for_regular_users
        if allow_host_namespace_for_regular_users is not None:
            self.allow_host_namespace_for_regular_users = allow_host_namespace_for_regular_users
        if allow_privileged_mode_for_regular_users is not None:
            self.allow_privileged_mode_for_regular_users = allow_privileged_mode_for_regular_users
        if allow_stack_management_for_regular_users is not None:
            self.allow_stack_management_for_regular_users = allow_stack_management_for_regular_users
        if allow_volume_browser_for_regular_users is not None:
            self.allow_volume_browser_for_regular_users = allow_volume_browser_for_regular_users
        if authentication_method is not None:
            self.authentication_method = authentication_method
        if black_listed_labels is not None:
            self.black_listed_labels = black_listed_labels
        if edge_agent_checkin_interval is not None:
            self.edge_agent_checkin_interval = edge_agent_checkin_interval
        if enable_edge_compute_features is not None:
            self.enable_edge_compute_features = enable_edge_compute_features
        if enable_host_management_features is not None:
            self.enable_host_management_features = enable_host_management_features
        if enable_telemetry is not None:
            self.enable_telemetry = enable_telemetry
        if ldap_settings is not None:
            self.ldap_settings = ldap_settings
        if logo_url is not None:
            self.logo_url = logo_url
        if o_auth_settings is not None:
            self.o_auth_settings = o_auth_settings
        if snapshot_interval is not None:
            self.snapshot_interval = snapshot_interval
        if templates_url is not None:
            self.templates_url = templates_url
        if user_session_timeout is not None:
            self.user_session_timeout = user_session_timeout
        if display_donation_header is not None:
            self.display_donation_header = display_donation_header
        if display_external_contributors is not None:
            self.display_external_contributors = display_external_contributors

    @property
    def allow_bind_mounts_for_regular_users(self):
        """Gets the allow_bind_mounts_for_regular_users of this PortainerSettings.  # noqa: E501


        :return: The allow_bind_mounts_for_regular_users of this PortainerSettings.  # noqa: E501
        :rtype: bool
        """
        return self._allow_bind_mounts_for_regular_users

    @allow_bind_mounts_for_regular_users.setter
    def allow_bind_mounts_for_regular_users(self, allow_bind_mounts_for_regular_users):
        """Sets the allow_bind_mounts_for_regular_users of this PortainerSettings.


        :param allow_bind_mounts_for_regular_users: The allow_bind_mounts_for_regular_users of this PortainerSettings.  # noqa: E501
        :type: bool
        """

        self._allow_bind_mounts_for_regular_users = allow_bind_mounts_for_regular_users

    @property
    def allow_container_capabilities_for_regular_users(self):
        """Gets the allow_container_capabilities_for_regular_users of this PortainerSettings.  # noqa: E501


        :return: The allow_container_capabilities_for_regular_users of this PortainerSettings.  # noqa: E501
        :rtype: bool
        """
        return self._allow_container_capabilities_for_regular_users

    @allow_container_capabilities_for_regular_users.setter
    def allow_container_capabilities_for_regular_users(self, allow_container_capabilities_for_regular_users):
        """Sets the allow_container_capabilities_for_regular_users of this PortainerSettings.


        :param allow_container_capabilities_for_regular_users: The allow_container_capabilities_for_regular_users of this PortainerSettings.  # noqa: E501
        :type: bool
        """

        self._allow_container_capabilities_for_regular_users = allow_container_capabilities_for_regular_users

    @property
    def allow_device_mapping_for_regular_users(self):
        """Gets the allow_device_mapping_for_regular_users of this PortainerSettings.  # noqa: E501


        :return: The allow_device_mapping_for_regular_users of this PortainerSettings.  # noqa: E501
        :rtype: bool
        """
        return self._allow_device_mapping_for_regular_users

    @allow_device_mapping_for_regular_users.setter
    def allow_device_mapping_for_regular_users(self, allow_device_mapping_for_regular_users):
        """Sets the allow_device_mapping_for_regular_users of this PortainerSettings.


        :param allow_device_mapping_for_regular_users: The allow_device_mapping_for_regular_users of this PortainerSettings.  # noqa: E501
        :type: bool
        """

        self._allow_device_mapping_for_regular_users = allow_device_mapping_for_regular_users

    @property
    def allow_host_namespace_for_regular_users(self):
        """Gets the allow_host_namespace_for_regular_users of this PortainerSettings.  # noqa: E501


        :return: The allow_host_namespace_for_regular_users of this PortainerSettings.  # noqa: E501
        :rtype: bool
        """
        return self._allow_host_namespace_for_regular_users

    @allow_host_namespace_for_regular_users.setter
    def allow_host_namespace_for_regular_users(self, allow_host_namespace_for_regular_users):
        """Sets the allow_host_namespace_for_regular_users of this PortainerSettings.


        :param allow_host_namespace_for_regular_users: The allow_host_namespace_for_regular_users of this PortainerSettings.  # noqa: E501
        :type: bool
        """

        self._allow_host_namespace_for_regular_users = allow_host_namespace_for_regular_users

    @property
    def allow_privileged_mode_for_regular_users(self):
        """Gets the allow_privileged_mode_for_regular_users of this PortainerSettings.  # noqa: E501


        :return: The allow_privileged_mode_for_regular_users of this PortainerSettings.  # noqa: E501
        :rtype: bool
        """
        return self._allow_privileged_mode_for_regular_users

    @allow_privileged_mode_for_regular_users.setter
    def allow_privileged_mode_for_regular_users(self, allow_privileged_mode_for_regular_users):
        """Sets the allow_privileged_mode_for_regular_users of this PortainerSettings.


        :param allow_privileged_mode_for_regular_users: The allow_privileged_mode_for_regular_users of this PortainerSettings.  # noqa: E501
        :type: bool
        """

        self._allow_privileged_mode_for_regular_users = allow_privileged_mode_for_regular_users

    @property
    def allow_stack_management_for_regular_users(self):
        """Gets the allow_stack_management_for_regular_users of this PortainerSettings.  # noqa: E501


        :return: The allow_stack_management_for_regular_users of this PortainerSettings.  # noqa: E501
        :rtype: bool
        """
        return self._allow_stack_management_for_regular_users

    @allow_stack_management_for_regular_users.setter
    def allow_stack_management_for_regular_users(self, allow_stack_management_for_regular_users):
        """Sets the allow_stack_management_for_regular_users of this PortainerSettings.


        :param allow_stack_management_for_regular_users: The allow_stack_management_for_regular_users of this PortainerSettings.  # noqa: E501
        :type: bool
        """

        self._allow_stack_management_for_regular_users = allow_stack_management_for_regular_users

    @property
    def allow_volume_browser_for_regular_users(self):
        """Gets the allow_volume_browser_for_regular_users of this PortainerSettings.  # noqa: E501


        :return: The allow_volume_browser_for_regular_users of this PortainerSettings.  # noqa: E501
        :rtype: bool
        """
        return self._allow_volume_browser_for_regular_users

    @allow_volume_browser_for_regular_users.setter
    def allow_volume_browser_for_regular_users(self, allow_volume_browser_for_regular_users):
        """Sets the allow_volume_browser_for_regular_users of this PortainerSettings.


        :param allow_volume_browser_for_regular_users: The allow_volume_browser_for_regular_users of this PortainerSettings.  # noqa: E501
        :type: bool
        """

        self._allow_volume_browser_for_regular_users = allow_volume_browser_for_regular_users

    @property
    def authentication_method(self):
        """Gets the authentication_method of this PortainerSettings.  # noqa: E501

        Active authentication method for the Portainer instance. Valid values are: 1 for internal, 2 for LDAP, or 3 for oauth  # noqa: E501

        :return: The authentication_method of this PortainerSettings.  # noqa: E501
        :rtype: int
        """
        return self._authentication_method

    @authentication_method.setter
    def authentication_method(self, authentication_method):
        """Sets the authentication_method of this PortainerSettings.

        Active authentication method for the Portainer instance. Valid values are: 1 for internal, 2 for LDAP, or 3 for oauth  # noqa: E501

        :param authentication_method: The authentication_method of this PortainerSettings.  # noqa: E501
        :type: int
        """

        self._authentication_method = authentication_method

    @property
    def black_listed_labels(self):
        """Gets the black_listed_labels of this PortainerSettings.  # noqa: E501

        A list of label name & value that will be used to hide containers when querying containers  # noqa: E501

        :return: The black_listed_labels of this PortainerSettings.  # noqa: E501
        :rtype: list[PortainerPair]
        """
        return self._black_listed_labels

    @black_listed_labels.setter
    def black_listed_labels(self, black_listed_labels):
        """Sets the black_listed_labels of this PortainerSettings.

        A list of label name & value that will be used to hide containers when querying containers  # noqa: E501

        :param black_listed_labels: The black_listed_labels of this PortainerSettings.  # noqa: E501
        :type: list[PortainerPair]
        """

        self._black_listed_labels = black_listed_labels

    @property
    def edge_agent_checkin_interval(self):
        """Gets the edge_agent_checkin_interval of this PortainerSettings.  # noqa: E501

        The default check in interval for edge agent (in seconds)  # noqa: E501

        :return: The edge_agent_checkin_interval of this PortainerSettings.  # noqa: E501
        :rtype: int
        """
        return self._edge_agent_checkin_interval

    @edge_agent_checkin_interval.setter
    def edge_agent_checkin_interval(self, edge_agent_checkin_interval):
        """Sets the edge_agent_checkin_interval of this PortainerSettings.

        The default check in interval for edge agent (in seconds)  # noqa: E501

        :param edge_agent_checkin_interval: The edge_agent_checkin_interval of this PortainerSettings.  # noqa: E501
        :type: int
        """

        self._edge_agent_checkin_interval = edge_agent_checkin_interval

    @property
    def enable_edge_compute_features(self):
        """Gets the enable_edge_compute_features of this PortainerSettings.  # noqa: E501

        Whether edge compute features are enabled  # noqa: E501

        :return: The enable_edge_compute_features of this PortainerSettings.  # noqa: E501
        :rtype: bool
        """
        return self._enable_edge_compute_features

    @enable_edge_compute_features.setter
    def enable_edge_compute_features(self, enable_edge_compute_features):
        """Sets the enable_edge_compute_features of this PortainerSettings.

        Whether edge compute features are enabled  # noqa: E501

        :param enable_edge_compute_features: The enable_edge_compute_features of this PortainerSettings.  # noqa: E501
        :type: bool
        """

        self._enable_edge_compute_features = enable_edge_compute_features

    @property
    def enable_host_management_features(self):
        """Gets the enable_host_management_features of this PortainerSettings.  # noqa: E501

        Deprecated fields v26  # noqa: E501

        :return: The enable_host_management_features of this PortainerSettings.  # noqa: E501
        :rtype: bool
        """
        return self._enable_host_management_features

    @enable_host_management_features.setter
    def enable_host_management_features(self, enable_host_management_features):
        """Sets the enable_host_management_features of this PortainerSettings.

        Deprecated fields v26  # noqa: E501

        :param enable_host_management_features: The enable_host_management_features of this PortainerSettings.  # noqa: E501
        :type: bool
        """

        self._enable_host_management_features = enable_host_management_features

    @property
    def enable_telemetry(self):
        """Gets the enable_telemetry of this PortainerSettings.  # noqa: E501

        Whether telemetry is enabled  # noqa: E501

        :return: The enable_telemetry of this PortainerSettings.  # noqa: E501
        :rtype: bool
        """
        return self._enable_telemetry

    @enable_telemetry.setter
    def enable_telemetry(self, enable_telemetry):
        """Sets the enable_telemetry of this PortainerSettings.

        Whether telemetry is enabled  # noqa: E501

        :param enable_telemetry: The enable_telemetry of this PortainerSettings.  # noqa: E501
        :type: bool
        """

        self._enable_telemetry = enable_telemetry

    @property
    def ldap_settings(self):
        """Gets the ldap_settings of this PortainerSettings.  # noqa: E501


        :return: The ldap_settings of this PortainerSettings.  # noqa: E501
        :rtype: PortainerLDAPSettings
        """
        return self._ldap_settings

    @ldap_settings.setter
    def ldap_settings(self, ldap_settings):
        """Sets the ldap_settings of this PortainerSettings.


        :param ldap_settings: The ldap_settings of this PortainerSettings.  # noqa: E501
        :type: PortainerLDAPSettings
        """

        self._ldap_settings = ldap_settings

    @property
    def logo_url(self):
        """Gets the logo_url of this PortainerSettings.  # noqa: E501

        URL to a logo that will be displayed on the login page as well as on top of the sidebar. Will use default Portainer logo when value is empty string  # noqa: E501

        :return: The logo_url of this PortainerSettings.  # noqa: E501
        :rtype: str
        """
        return self._logo_url

    @logo_url.setter
    def logo_url(self, logo_url):
        """Sets the logo_url of this PortainerSettings.

        URL to a logo that will be displayed on the login page as well as on top of the sidebar. Will use default Portainer logo when value is empty string  # noqa: E501

        :param logo_url: The logo_url of this PortainerSettings.  # noqa: E501
        :type: str
        """

        self._logo_url = logo_url

    @property
    def o_auth_settings(self):
        """Gets the o_auth_settings of this PortainerSettings.  # noqa: E501


        :return: The o_auth_settings of this PortainerSettings.  # noqa: E501
        :rtype: PortainerOAuthSettings
        """
        return self._o_auth_settings

    @o_auth_settings.setter
    def o_auth_settings(self, o_auth_settings):
        """Sets the o_auth_settings of this PortainerSettings.


        :param o_auth_settings: The o_auth_settings of this PortainerSettings.  # noqa: E501
        :type: PortainerOAuthSettings
        """

        self._o_auth_settings = o_auth_settings

    @property
    def snapshot_interval(self):
        """Gets the snapshot_interval of this PortainerSettings.  # noqa: E501

        The interval in which endpoint snapshots are created  # noqa: E501

        :return: The snapshot_interval of this PortainerSettings.  # noqa: E501
        :rtype: str
        """
        return self._snapshot_interval

    @snapshot_interval.setter
    def snapshot_interval(self, snapshot_interval):
        """Sets the snapshot_interval of this PortainerSettings.

        The interval in which endpoint snapshots are created  # noqa: E501

        :param snapshot_interval: The snapshot_interval of this PortainerSettings.  # noqa: E501
        :type: str
        """

        self._snapshot_interval = snapshot_interval

    @property
    def templates_url(self):
        """Gets the templates_url of this PortainerSettings.  # noqa: E501

        URL to the templates that will be displayed in the UI when navigating to App Templates  # noqa: E501

        :return: The templates_url of this PortainerSettings.  # noqa: E501
        :rtype: str
        """
        return self._templates_url

    @templates_url.setter
    def templates_url(self, templates_url):
        """Sets the templates_url of this PortainerSettings.

        URL to the templates that will be displayed in the UI when navigating to App Templates  # noqa: E501

        :param templates_url: The templates_url of this PortainerSettings.  # noqa: E501
        :type: str
        """

        self._templates_url = templates_url

    @property
    def user_session_timeout(self):
        """Gets the user_session_timeout of this PortainerSettings.  # noqa: E501

        The duration of a user session  # noqa: E501

        :return: The user_session_timeout of this PortainerSettings.  # noqa: E501
        :rtype: str
        """
        return self._user_session_timeout

    @user_session_timeout.setter
    def user_session_timeout(self, user_session_timeout):
        """Sets the user_session_timeout of this PortainerSettings.

        The duration of a user session  # noqa: E501

        :param user_session_timeout: The user_session_timeout of this PortainerSettings.  # noqa: E501
        :type: str
        """

        self._user_session_timeout = user_session_timeout

    @property
    def display_donation_header(self):
        """Gets the display_donation_header of this PortainerSettings.  # noqa: E501

        Deprecated fields  # noqa: E501

        :return: The display_donation_header of this PortainerSettings.  # noqa: E501
        :rtype: bool
        """
        return self._display_donation_header

    @display_donation_header.setter
    def display_donation_header(self, display_donation_header):
        """Sets the display_donation_header of this PortainerSettings.

        Deprecated fields  # noqa: E501

        :param display_donation_header: The display_donation_header of this PortainerSettings.  # noqa: E501
        :type: bool
        """

        self._display_donation_header = display_donation_header

    @property
    def display_external_contributors(self):
        """Gets the display_external_contributors of this PortainerSettings.  # noqa: E501


        :return: The display_external_contributors of this PortainerSettings.  # noqa: E501
        :rtype: bool
        """
        return self._display_external_contributors

    @display_external_contributors.setter
    def display_external_contributors(self, display_external_contributors):
        """Sets the display_external_contributors of this PortainerSettings.


        :param display_external_contributors: The display_external_contributors of this PortainerSettings.  # noqa: E501
        :type: bool
        """

        self._display_external_contributors = display_external_contributors

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PortainerSettings, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PortainerSettings):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PortainerSettings):
            return True

        return self.to_dict() != other.to_dict()
