# coding: utf-8

"""
    PortainerCE API

    Portainer API is an HTTP API served by Portainer. It is used by the Portainer UI and everything you can do with the UI can be done using the HTTP API. Examples are available at https://documentation.portainer.io/api/api-examples/ You can find out more about Portainer at [http://portainer.io](http://portainer.io) and get some support on [Slack](http://portainer.io/slack/).  # Authentication  Most of the API endpoints require to be authenticated as well as some level of authorization to be used. Portainer API uses JSON Web Token to manage authentication and thus requires you to provide a token in the **Authorization** header of each request with the **Bearer** authentication mechanism.  Example:  ``` Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpZCI6MSwidXNlcm5hbWUiOiJhZG1pbiIsInJvbGUiOjEsImV4cCI6MTQ5OTM3NjE1NH0.NJ6vE8FY1WG6jsRQzfMqeatJ4vh2TWAeeYfDhP71YEE ```  # Security  Each API endpoint has an associated access policy, it is documented in the description of each endpoint.  Different access policies are available:  - Public access - Authenticated access - Restricted access - Administrator access  ### Public access  No authentication is required to access the endpoints with this access policy.  ### Authenticated access  Authentication is required to access the endpoints with this access policy.  ### Restricted access  Authentication is required to access the endpoints with this access policy. Extra-checks might be added to ensure access to the resource is granted. Returned data might also be filtered.  ### Administrator access  Authentication as well as an administrator role are required to access the endpoints with this access policy.  # Execute Docker requests  Portainer **DOES NOT** expose specific endpoints to manage your Docker resources (create a container, remove a volume, etc...).  Instead, it acts as a reverse-proxy to the Docker HTTP API. This means that you can execute Docker requests **via** the Portainer HTTP API.  To do so, you can use the `/endpoints/{id}/docker` Portainer API endpoint (which is not documented below due to Swagger limitations). This endpoint has a restricted access policy so you still need to be authenticated to be able to query this endpoint. Any query on this endpoint will be proxied to the Docker API of the associated endpoint (requests and responses objects are the same as documented in the Docker API).  **NOTE**: You can find more information on how to query the Docker API in the [Docker official documentation](https://docs.docker.com/engine/api/v1.30/) as well as in [this Portainer example](https://documentation.portainer.io/api/api-examples/).   # noqa: E501

    OpenAPI spec version: 2.6.0
    Contact: info@portainer.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from portainer_ce_api.configuration import Configuration


class EdgejobsEdgeJobCreateFromFilePayload(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'cron_expression': 'str',
        'endpoints': 'list[int]',
        'file': 'list[int]',
        'name': 'str',
        'recurring': 'bool'
    }

    attribute_map = {
        'cron_expression': 'cronExpression',
        'endpoints': 'endpoints',
        'file': 'file',
        'name': 'name',
        'recurring': 'recurring'
    }

    def __init__(self, cron_expression=None, endpoints=None, file=None, name=None, recurring=None, _configuration=None):  # noqa: E501
        """EdgejobsEdgeJobCreateFromFilePayload - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._cron_expression = None
        self._endpoints = None
        self._file = None
        self._name = None
        self._recurring = None
        self.discriminator = None

        if cron_expression is not None:
            self.cron_expression = cron_expression
        if endpoints is not None:
            self.endpoints = endpoints
        if file is not None:
            self.file = file
        if name is not None:
            self.name = name
        if recurring is not None:
            self.recurring = recurring

    @property
    def cron_expression(self):
        """Gets the cron_expression of this EdgejobsEdgeJobCreateFromFilePayload.  # noqa: E501


        :return: The cron_expression of this EdgejobsEdgeJobCreateFromFilePayload.  # noqa: E501
        :rtype: str
        """
        return self._cron_expression

    @cron_expression.setter
    def cron_expression(self, cron_expression):
        """Sets the cron_expression of this EdgejobsEdgeJobCreateFromFilePayload.


        :param cron_expression: The cron_expression of this EdgejobsEdgeJobCreateFromFilePayload.  # noqa: E501
        :type: str
        """

        self._cron_expression = cron_expression

    @property
    def endpoints(self):
        """Gets the endpoints of this EdgejobsEdgeJobCreateFromFilePayload.  # noqa: E501


        :return: The endpoints of this EdgejobsEdgeJobCreateFromFilePayload.  # noqa: E501
        :rtype: list[int]
        """
        return self._endpoints

    @endpoints.setter
    def endpoints(self, endpoints):
        """Sets the endpoints of this EdgejobsEdgeJobCreateFromFilePayload.


        :param endpoints: The endpoints of this EdgejobsEdgeJobCreateFromFilePayload.  # noqa: E501
        :type: list[int]
        """

        self._endpoints = endpoints

    @property
    def file(self):
        """Gets the file of this EdgejobsEdgeJobCreateFromFilePayload.  # noqa: E501


        :return: The file of this EdgejobsEdgeJobCreateFromFilePayload.  # noqa: E501
        :rtype: list[int]
        """
        return self._file

    @file.setter
    def file(self, file):
        """Sets the file of this EdgejobsEdgeJobCreateFromFilePayload.


        :param file: The file of this EdgejobsEdgeJobCreateFromFilePayload.  # noqa: E501
        :type: list[int]
        """

        self._file = file

    @property
    def name(self):
        """Gets the name of this EdgejobsEdgeJobCreateFromFilePayload.  # noqa: E501


        :return: The name of this EdgejobsEdgeJobCreateFromFilePayload.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this EdgejobsEdgeJobCreateFromFilePayload.


        :param name: The name of this EdgejobsEdgeJobCreateFromFilePayload.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def recurring(self):
        """Gets the recurring of this EdgejobsEdgeJobCreateFromFilePayload.  # noqa: E501


        :return: The recurring of this EdgejobsEdgeJobCreateFromFilePayload.  # noqa: E501
        :rtype: bool
        """
        return self._recurring

    @recurring.setter
    def recurring(self, recurring):
        """Sets the recurring of this EdgejobsEdgeJobCreateFromFilePayload.


        :param recurring: The recurring of this EdgejobsEdgeJobCreateFromFilePayload.  # noqa: E501
        :type: bool
        """

        self._recurring = recurring

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EdgejobsEdgeJobCreateFromFilePayload, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EdgejobsEdgeJobCreateFromFilePayload):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, EdgejobsEdgeJobCreateFromFilePayload):
            return True

        return self.to_dict() != other.to_dict()
